/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

import {fetchWithToken, tokenStore} from "./repo.ts";
import {type Schematic, SchematicSchema} from "@type/schem.ts";
import {derived} from "svelte/store";
import {ResponseErrorSchema} from "@type/data.ts";

export class SchematicRepo {
    constructor(private token: string) {
    }

    public async getSchematicCodeInfo(code: string): Promise<Schematic> {
        return await fetchWithToken(this.token, `/download/${code}/info`).then(value => value.json()).then(SchematicSchema.parse);
    }

    public getSchematicDownloadUrl(code: string): string {
        return `${import.meta.env.PUBLIC_API_SERVER}/download/${code}`;
    }

    public async uploadSchematic(name: string, content: string) {
        return await fetchWithToken(this.token, "/schem", {
            method: "POST",
            body: JSON.stringify({
                name,
                content,
            }),
        }).then(value => value.json()).then(SchematicSchema.or(ResponseErrorSchema).parse);
    }
}

export const schemRepo = derived(tokenStore, ($token) => new SchematicRepo($token));